\appendix
\chapter{Appendix}
\section{Building management}
\subsection{Additional illustrations of the metamodel}
\label{sec:additional_illustrations}
\begin{figure}[htpb]
	\centering
	\caption{Inference from the metamodel compared to the ground truth (TRNSYS simulation), on a sample of the validation dataset.}%
	\includegraphics[width=.9\linewidth]{images/metamodel/metamodel_training_visuals.jpg}
\end{figure}

\begin{figure}[htpb]
	\centering
	\includegraphics[width=.9\linewidth]{images/calib-optim/optim_livingstone_elec.png}
	\includegraphics[width=.9\linewidth]{images/calib-optim/optim_livingstone_tint.png}
	\caption{Indoor temperature and consumption for Real data, Calibration and Optimization for Livingstone.}%
\end{figure}

\clearpage
\newpage

\subsection{Ranges used to train the metamodel}
\label{sec:metamodel_ranges}
\begin{table}[ht]
	\centering
	%\resizebox{\textwidth}{!}{%
	\begin{tabular}{cccc}
		Variable                                                                        & Minimum & Maximum & Step \\
		\hline
		airchange\_infiltration\_vol\_per\_h ($\mathrm{m}^3\mathrm{h}^{-1}$)            & 0.1     & 0.5     & 0.1  \\
		capacitance\_kJ\_perdegreK\_perm3 ($\mathrm{kJ}\mathrm{K}^{-1}\mathrm{m}^{-3}$) & 50      & 300     & 10   \\
		power\_VCV\_kW\_heat ($\mathrm{kW}$)                                            & 0       & 1000    & 100  \\
		power\_VCV\_kW\_clim ($\mathrm{kW}$)                                            & 0       & 1000    & 100  \\
		nb\_occupants                                                                   & 1000    & 2000    & 200  \\
		nb\_PCs                                                                         & 1000    & 2000    & 200  \\
		percent\_light\_night                                                           & 0       & 70      & 10   \\
		percent\_PCs\_night                                                             & 0       & 70      & 10   \\
		facade\_1\_thickness\_2 ($\mathrm{m}$)                                          & 0.05    & 0.15    & 0.05 \\
		facade\_2\_thickness\_2 ($\mathrm{m}$)                                          & 0.05    & 0.15    & 0.05 \\
		facade\_3\_thickness\_2 ($\mathrm{m}$)                                          & 0.05    & 0.15    & 0.05 \\
		facade\_4\_thickness\_2 ($\mathrm{m}$)                                          & 0.05    & 0.15    & 0.05 \\
		roof\_1\_thickness\_3 ($\mathrm{m}$)                                            & 0.05    & 0.15    & 0.05 \\
		facade\_1\_window\_area\_percent                                                & 40      & 50      & 5    \\
		facade\_2\_window\_area\_percent                                                & 40      & 50      & 5    \\
		facade\_3\_window\_area\_percent                                                & 40      & 50      & 5    \\
		facade\_4\_window\_area\_percent                                                & 40      & 50      & 5    \\
		\hline
		start\_occupation\_monday (h)                                                   & 7       & 9       & 1    \\
		start\_occupation\_tuesday (h)                                                  & 7       & 9       & 1    \\
		start\_occupation\_wednesday (h)                                                & 7       & 9       & 1    \\
		start\_occupation\_thursday (h)                                                 & 7       & 9       & 1    \\
		start\_occupation\_friday  (h)                                                  & 7       & 9       & 1    \\
		end\_occupation\_monday (h)                                                     & 17      & 20      & 1    \\
		end\_occupation\_tuesday (h)                                                    & 17      & 20      & 1    \\
		end\_occupation\_wednesday (h)                                                  & 17      & 20      & 1    \\
		end\_occupation\_thursday  (h)                                                  & 17      & 20      & 1    \\
		end\_occupation\_friday  (h)                                                    & 17      & 20      & 1    \\
		\hline                                                                                                     \\
	\end{tabular}%}
	\caption{List of parameters contained in $\lambda$ and $\delta$, along with sampling and calibration ranges. During training of the metamodel, occupation values are converted in a one dimensional time series, with value $0$ or $1$ based on the occupation state of the building.}
	\label{tab:lambda}
\end{table}

\begin{table}[ht]
	\centering
	\begin{tabular}{cccc}
		Variable                                 & Minimum & Maximum & Step \\
		\hline
		start\_clim\_day (h)                     & 7       & 9       & 1    \\
		end\_clim\_day (h)                       & 18      & 20      & 1    \\
		t\_clim\_red\_day ($^\circ\mathrm{C}$)   & 24      & 30      & 0.5  \\
		t\_clim\_conf\_day ($^\circ\mathrm{C}$)  & 20      & 24      & 0.5  \\
		start\_heat\_day (h)                     & 6       & 8       & 1    \\
		end\_heat\_day (h)                       & 17      & 19      & 1    \\
		t\_heat\_red\_day ($^\circ\mathrm{C}$)   & 17      & 22      & 0.5  \\
		t\_heat\_conf\_day ($^\circ\mathrm{C}$)  & 22      & 24      & 0.5  \\
		start\_ventilation\_day (h)              & 7       & 9       & 1    \\
		end\_ventilation\_day (h)                & 18      & 20      & 1    \\
		t\_ventilation\_day ($^\circ\mathrm{C}$) & 18      & 26      & 0.5  \\
		vol\_ventilation\_day                    & 0.7     & 1.7     & 0.3  \\
		\hline                                                              \\
	\end{tabular}
	\caption{List of variables contained in $\psi_k$, along with their ranges. Each parameter can hold a different value for each day of the week. For ease of reading, we replaced them by a single line, as the ranges are the same for every day.}
	\label{tab:psi}
\end{table}

\begin{table}[ht]
	\centering
	\begin{tabular}{*2c}
		Variable & Description                   \\
		\hline
		DNI      & Direct Normal Irradiance      \\
		IBEAM\_H & Direct Horizontal Irradiance  \\
		IBEAM\_N & Direct Normal Irradiance      \\
		IDIFF\_H & Diffuse Horizontal Irradiance \\
		IGLOB\_H & Global Horizontal Irradiance  \\
		RHUM     & Outdoor Relative Humidity     \\
		TAMB     & Outdoor temperature           \\
		\hline                                   \\
	\end{tabular}
	\caption{Weather data as contained in $\varphi_k$.}
	\label{tab:phi}
\end{table}

\begin{table}[ht]
	\centering
	%\resizebox{\textwidth}{!}{%
	\begin{tabular}{cc}
		Variable        & Description                                                     \\
		\hline
		Q\_AC\_OFFICE   & AC consumption                                                  \\
		Q\_HEAT\_OFFICE & Heat consumption                                                \\
		Q\_PEOPLE       & Heating power due to human activities in the building           \\
		Q\_EQP          & Consumption of equipment, such as computers, elevators, fridges \\
		Q\_LIGHT        & Consumption of lights                                           \\
		Q\_AHU\_C       & Consumption of AHU when cooling outside air                     \\
		Q\_AHU\_H       & Consumption of AHU when heating outside air                     \\
		T\_INT\_OFFICE  & Indoor temperature                                              \\
		\hline                                                                            \\
	\end{tabular}%}
	\caption{Output variables of the equivalent model designed by the energy managers.}
	\label{tab:Yk}
\end{table}

\subsection{Additional air quality forecasting samples}
\label{app:airq}
\begin{figure}[htpb]
	\centering
	\caption{Prediction of Relative Humidity given observations on two additional 24 hour samples, by the LSTM model.
		The neural network is able to model general trends, but fails at grasping hour to hour behaviors.}
	\includegraphics[width=0.6\linewidth]{images/airq/lstm/oze_3.png}
	\includegraphics[width=0.6\linewidth]{images/airq/lstm/oze_4.png}
	\label{fig:chap1app-airq-lstm}
\end{figure}

\section{Prior models}
\subsection{Details on the loss function}
\label{ap:loss}
\begin{proof}[Proof of Lemma~\ref{lem:loss}]
	By definition,
	$$
		\mathcal{L}(\theta,\phi) = \mathbb{E}_{q_{\varphi}}\left[\log \frac{p_{\theta}(\quantized^{0:T},\latentcont^{0:T},x)}{q_{\varphi}(\quantized^{0:T},\latentcont^{0:T}| x)}\right]\,,
	$$
	which yields
	$$
		\mathcal{L}(\theta,\phi) = \mathbb{E}_{q_{\varphi}}\left[\log p^x_{\theta}(x|\quantized^{0})\right]  + \mathbb{E}_{q_{\varphi}}\left[\log \frac{p^{\quantized}_{\theta}(\quantized^{0:T}|\latentcont^{0:T})}{q^{\quantized}_{\varphi}(\quantized^{0:T}|\latentcont^{0:T})}\right] +\mathbb{E}_{q_{\varphi}}\left[\log \frac{p^{\latentcont}_{\theta}(\latentcont^{0:T})}{q^{\latentcont}_{\varphi}(\latentcont^{0:T}| x)}\right]\,.
	$$
	The last term may be decomposed as
	$$
		\mathbb{E}_{q_{\phi}}\left[\log \frac{p^{\latentcont}_{\theta}(\latentcont^{0:T})}{q^{\latentcont}_{\varphi}(\latentcont^{0:T}| x)}\right] = \mathbb{E}_{q_{\varphi}}\left[\log p^{\latentcont}_{\theta,T}(\latentcont^{T})\right] + \sum_{t=1}^T \mathbb{E}_{q_{\varphi}}\left[\log \frac{p^{\latentcont}_{\theta,t-1|t}(\latentcont^{t-1}|\latentcont^{t})}{q^{\latentcont}_{\varphi,t|t-1}(\latentcont^{t}|\latentcont^{t-1})}\right]
	$$
	and
	$$
		\mathbb{E}_{q_{\phi}}\left[\log \frac{p^{\latentcont}_{\theta}(\latentcont^{0:T})}{q^{\latentcont}_{\varphi}(\latentcont^{0:T}| x)}\right] = \mathbb{E}_{q_{\varphi}}\left[\log p^{\latentcont}_{\theta,T}(\latentcont^{T})\right] +\mathbb{E}_{q_{\varphi}}\left[\log \frac{p^{\latentcont}_{\theta,0|1}(\latentcont^{0}|\latentcont^{1})}{q^{\latentcont}_{\varphi,1|0}(\latentcont^{1}|\latentcont^{0})}\right] + \sum_{t=2}^T \mathbb{E}_{q_{\varphi}}\left[\log \frac{p^{\latentcont}_{\theta,t-1|t}(\latentcont^{t-1}|\latentcont^{t})}{q^{\latentcont}_{\varphi,t|t-1}(\latentcont^{t}|\latentcont^{t-1})}\right]\,.
	$$
	By \eqref{eq:markov:bridge},
	$$
		\mathbb{E}_{q_{\phi}}\left[\log \frac{p^{\latentcont}_{\theta}(\latentcont^{0:T})}{q^{\latentcont}_{\varphi}(\latentcont^{0:T}| x)}\right] = \mathbb{E}_{q_{\varphi}}\left[\log \frac{p^{\latentcont}_{\theta,T}(\latentcont^{T})}{q^{\latentcont}_{\varphi,T|0}(\latentcont^{T}|\latentcont^{0})}\right] + \sum_{t=2}^T \mathbb{E}_{q_{\varphi}}\left[\log \frac{p^{\latentcont}_{\theta,t-1|t}(\latentcont^{t-1}|\latentcont^{t})}{q^{\latentcont}_{\varphi,t-1|0,t}(\latentcont^{t-1}|\latentcont^{0},\latentcont^{t})}\right] + \mathbb{E}_{q_{\varphi}}\left[\log p^{\latentcont}_{\theta,0|1}(\latentcont^{0}|\latentcont^{1})\right]\,,
	$$
	which concludes the proof.
\end{proof}

\subsection{Inpainting diffusion sampling}
\label{ap:inpainting}

We consider the case in which we know a sub-part of the picture $\overline{X}$, and want to predict the complementary pixels $\underline{X}$. Knowing the corresponding $n$ latent vectors $\overline{\latentcont}^0$ which result from $\underline{X}$ through the encoder, we sample $N - n$ $\underline{\latentcont}^T$ from the uninformative distribution $\underline{\latentcont}^T \sim \mathcal{N}(0, (2\vartheta)^{-1}\eta^2 \mathbf{I}_{d \times (N - n)})$. In order to produce the chain of samples $\latentcont^{t-1}$ from $\latentcont^t$ we then follow the following procedure.
\begin{itemize}
	\item $\underline{\latentcont}^{t-1}$ is predicted from $\latentcont^t$ using the neural network predictor, similar to the unconditioned case. %Only the unknown part $\underline{\latentcont}^{t-1}$ is kept.
	\item Sample $\overline{\latentcont}^{t-1}$ using the forward bridge noising process.
	      %\item $\latentcont^{t-1} = \overline{\latentcont}^{t-1} \cup  \underline{\latentcont}^{t-1}$
\end{itemize}


% Alternative: For our prior, we sample at time $T$ from the uninformative distribution  and start the denoising process. At each time step $t$ of this process, we sample as usual from $p_{\theta,t-1|t}^{\latentcont}(\latentcont^{t-1}|\latentcont^{t})$ and mask it with a sample from $\bckw^{\latentcont}_{\phi,t|0,T}(\latentcont^t|\latentcont^0,\latentcont^T)$ or using the forward trajectory obtained with the transition density $\bckw^{\latentcont}_{\varphi,t|t-1}$. In our experiments, we did not notice significant differences using one or the other.%

\subsection{Additional regularisation considerations}
\label{ap:reg}

We consider here details about the parameterisation of $p_{\theta}^{\quantized}(\quantized^t|\latentcont^t)$ and $q_{\phi}^{\quantized}(\quantized^t|\latentcont^t)$ in order to compute $\mathcal{L}^{reg}_t(\theta,\varphi)$.
Using the Gumbel-Softmax formulation provides an efficient and differentiable parameterisation.
\begin{align*}
	p_{\theta,t}^{\quantized}(\quantized^t = \cdot|\latentcont^t) & = \mathrm{Softmax}\{(-\|\latentcont - \codebook_k\|^2_2 + G_k )/\tau_t\}_{1\leqslant k \leqslant K}\,,      \\
	q_{\phi,t}(\quantized^t = \cdot|\latentcont^t)                & = \mathrm{Softmax}\{(-\|\latentcont - \codebook_k\|^2_2 + \tilde G_k )/\tau\}_{1\leqslant k \leqslant K}\,,
\end{align*}
where $\{(G_k,\tilde G_k)\}_{1\leqslant k \leqslant K}$ are i.i.d. with distribution $\mathrm{Gumbel}(0,1)$, $\tau>0$, and $\{\tau_t\}_{0\leqslant t \leqslant T}$ are positive time-dependent scaling parameters. Then, up to the additive normalizing terms,
\begin{align*}
	\mathcal{L}^{reg}_t(\theta,\phi) = \mathbb{E}_{q_{\varphi}}\left[\log \frac{p_{\theta,t}^{\quantized}(\quantized^{t}|\latentcont^{t})}{q_{\varphi,t}^{\quantized}(\quantized^{t}|\latentcont^{t})}\right] & = \left(-\frac{1}{\tau_t} + \frac{1}{\tau}\right)\|\latentcont^t - \widehat{\quantized^t}\|_2^2  - \frac{\tilde G_k}{\tau} + \frac{G_k}{\tau_t}\,,
	%\\&+ \log \left(\sum_{k=1}^{K}\exp\left\{\frac{-\|\latentcont^t-\codebook_k\|_2 + \tilde G_k}{\tau} \right\}\right) \\&+ \log \left(\sum_{k=1}^{K}\exp\left\{\frac{-\|\latentcont^t-\codebook_k\|_2 + G_k)}{\tau_t}\right\}\right)
\end{align*}
where $\widehat{\quantized^t}\sim q_{\phi,t}^{\quantized}(\quantized^{t}|\latentcont^{t})$. Considering only the first term which depend on $\latentcont^t$ and produce non-zero gradients, we get:
$$
	\mathcal{L}^{reg}_t(\theta,\phi) = \gamma_t \|\latentcont^t - \widehat{\quantized^t}\|_2^2
$$
where $\gamma_t = -1/\tau_t + 1/\tau$ drives the behavior of the regulariser. By choosing is $\gamma_t$ negative for large $t$, the regulariser pushes the codebooks away from $\latentcont^t$, which prevents too early specialization, or matching of codebooks with noise, as $\latentcont^{t \approx T}$ is close to the uninformative distribution. Finally, for small $t$, choosing $\gamma_t$ positive helps matching codebooks with $\latentcont$ when the corruption is small. In practice $\tau=1$ and a simple schedule from $10$ to $0.1$ for $\tau_t$ was considered in this work.

\subsection{Neural Networks}
\label{ap:networks}
For $\varepsilon_\theta(\latentcont^t ,t)$, we use a U-net like architecture similar to the one mentioned in \cite{ho2020denoising}. It consists of a deep convolutional neural network with 57M parameters, which is slightly below the PixelCNN architecture (95.8M parameters). The VQ-VAE encoder / decoders are also deep convolutional networks totalling 65M parameters.

\subsection{Toy Example Appendix}
\label{ap:additionaltoy}

\paragraph{Parameterisation}

We consider a neural network to model $\varepsilon_\theta(\latentcont^t ,t)$. The network shown in Figure \ref{ap:fig:toynetwork} consists of a time embedding similar to \cite{ho2020denoising}, as well as a few linear or 1D-convolutional layers, totalling around $5000$ parameters.

\begin{figure}[h!]
	\centering
	\includegraphics[scale=2.0]{images/diffusion-bridges/toy/archi.png}
	\caption{Graphical representation of the neural network used for the toy dataset.}
	\label{ap:fig:toynetwork}
\end{figure}

For the parameterisation of the quantization part, we choose $p_{\theta,t}^{\quantized}(\quantized^{t}=\codebook_j|\latentcont^{t}) = \mathrm{Softmax}_{1\leq k \leq K}\{-\|\latentcont - \codebook_k\|_2\}_j$, and the same parameterisation for $q_{\phi,t}^{\quantized}(\quantized^{t}|\latentcont^{t})$. Therefore our loss simplifies to:
$$
	\mathcal{L}(\theta,\phi) = \mathbb{E}_{q_{\varphi}}\left[\log p^x_{\theta}(x|\quantized^{0})\right] + \mathcal{L}_t(\theta,\varphi)\,,
$$

where $t$ is sampled uniformly in $\{0,\ldots,T\}$.

\paragraph{Discrete samples during diffusion process}

\begin{table}[h!]

	\centering
	\begin{tabular}{l|c}
		t  & NN sequence     \\
		\hline
		50 & (0, 7, 3, 6, 2) \\
		40 & (6, 5, 5, 5, 3) \\
		30 & (5, 5, 5, 4, 2) \\
		20 & (6, 6, 5, 4, 3) \\
		10 & (5, 6, 5, 4, 3) \\
		0  & (5, 6, 5, 4, 3)
	\end{tabular}
	\caption{\label{ap:tab:discretetoy} Discrete samples during diffusion process. The discrete sequence is obtained by computing the nearest neighbour centroid $\mu_j$ for each $X^t_s$. At $t=0$, $X^0$ is sampled from a centered Gaussian distribution with small covariance matrix $(2\vartheta)^{-1}\eta^2\mathbf{I}_{2\times 5}$, resulting in a uniform discrete sequence, as all centroids have a similar unit norm.}

\end{table}


Discrete sequences corresponding to the denoising diffusion process shown in Figure \ref{fig:noisedenoise} are shown in Table~\ref{ap:tab:discretetoy}.

\paragraph{End-to-end training}
\label{ap:end2end}
In order to train the codebooks alongside the diffusion process, we need to backpropagate the gradient of the likelihood of the data $\latentcont$ given a $\latentcont^0$ reconstructed by the diffusion process (corresponding to $\mathcal{L}^{rec}(\theta,\phi)$). We use the Gumbel-Softmax parameterisation in order to obtain a differentiable process and update the codebooks $\codebook_j$.

In this toy example, the use of the third part of the loss $\sum_{t=0}^T \mathcal{L}^{reg}_t(\theta,\phi)$ is not mandatory as we obtain good results with $\mathcal{L}^{reg}_t(\theta,\varphi) = 0$, which means parametrising $p_{\theta,t}^{\quantized}(\quantized^t|\latentcont^t) = q_{\varphi,t}^{\quantized}(\quantized^t|\latentcont^t)$. However we noticed that $\mathcal{L}^{reg}_t(\theta,\varphi)$ is useful to improve the learning of the codebooks. If we choose $\gamma_t$ to be decreasing with time $t$, we have the following. When $t$ is low, the denoising process is almost over, $\mathcal{L}^{reg}_t(\theta,\varphi)$ pushes $\latentcont$ and the selected $\quantized$ to close together: $\|\latentcont\| \sim 1$, then $\|\latentcont^t\|$ will be likely near a specific $\codebook_j$ and far from the others; therefore only a single codebook is selected and receives gradient. When $t$ is high, $\|\latentcont^t\| \sim 0$ and the Gumbel-Softmax makes it so that all codebooks are equidistant from $\|\latentcont^t\|$ and receive non-zero gradient. This naturally solves training problem associated with dead codebooks in VQ-VAEs. Joint training of the denoising and codebooks yield excellent codebook positionning as shown in Figure \ref{ap:codebooks}.

\begin{figure}[h!]
	\centering
	\includegraphics[scale=0.4]{images/diffusion-bridges/toy/centroids_training.png}
	\caption{Left, initial random codebooks positions. Right, after training, position of codebook vectors. Note that the codebook indexes do not match the indexes of the Gaussians, the model learnt to make the associations between neighboring centroids in a different order.}
	\label{ap:codebooks}
\end{figure}

\paragraph{Toy Diffusion inpainting}

\label{ap:toyinpainting}
We consider a case in which we want to reconstruct an $x$ while we only know one (or a few) dimensions, and sample the others. Consider that $x$ is generated using a sequence $q= (q_1,q_2,q_",q_4,q_5)$ where the last one if fixed $q_1 = 0, q_5 = 4$. Then, knowing $q_1, q_5$, we sample $q_2,q_3,q_4$, as shown in Figure \ref{fig:fixeddim}.
\begin{figure}[h!]
	\centering
	\includegraphics[scale=0.5]{images/diffusion-bridges/toy/sampling.png}
	\caption{Three independent sampling of $X$ using a trained diffusion bridge, with fixed $q_1 = 0, q_5 = 4$. The three corresponding sequences are $(0,7,6,5,4)$, $(0,1,2,3,4)$, $(0,7,6,5,4)$ all valid sequences.}
	\label{fig:fixeddim}
\end{figure}




% \section{On NLL evaluation}
% \paragraph{PixelCNN}%
% In PixelCNN, the authors clearly state that a single scalar value in produced for each pixel (and each channel): \textit{Each pixel $x_i$ is in turn jointly determined by three values, one for each of the color channels Red, Green and Blue (RGB).}.
% But one paragraph later, they seem to claim the opposite: \textit{we model $p(x)$ as a discrete distribution, with every conditional distribution being a multinomial that is modeled with a softmax layer. Each channel variable $x_i$ simply takes one of 256 distinct values}.
% Then, in Section 5.1, there is a discussion on comparing continuous and discrete distributions, by adding real valued noise, which I couldn't make sense of.
% In the face of all previous evidences, and considering they measure the NLL in \textit{bits/dim}, I have come to the conclusion that PixelCNN outputs a discrete distribution for each pixel, then compares it to the continuous distribution of the dataset.
% Since there is no latent space of interest, these NLL must be computed directly on image pixels.

% \paragraph{VQVAE}%
% The output type of the VQVAE model, as well as its evaluation methods are still unclear to me.
% On the one hand, the authors mention \textit{likelihood lower bounds} in \textit{bits/dim}, providing values matching those reported in PixelCNN.
% In a section called \textit{Comparison with continuous variables}, which I interpret as being a reference to the discrete nature of the latent space, they compare themselves to classic VAE and VIMCO.
% We can assume this metric refers to image pixels (same as PixelCNN), and not to the latent space.

% On the other hand, in the official implementation of the vqvae and the example notebook provided along, the model outputs a scalar value for each pixel.
% The only cost function used during training were the MSE and the commitment loss, no NLL was mentioned or computed.
% There is no doubt on the nature of that particular model since, when plotting images, they use an interpolation function.

% \paragraph{VQVAE-2}%
% In VQVAE-2, the NLL is \textit{not used for comparing} with state of the art, but only as an overfit sanity check.
% Indeed, the NLL seems to be computed on the latent spaces, as the authors mention \textit{We note that these NLL values are only comparable between prior models that use the same pretrained VQ-VAE encoder and decoder}.
% Instead of NLL, they use two kind of evaluation metrics:
% \begin{itemize}
% 	\item Corrected FID
% 	\item Classification Accuracy Score: for class-conditional generative models only.
% \end{itemize}

% \paragraph{Conclusion}%
% \textbf{The VQVAE} mentions having computed a likelihood lower bound, but no details are provided. The official implementation is not coherent with this metric, as only the MSE can be computed.
% \textbf{The VQVAE-2} computes the NLL, but only on its own latent space, thus can't be compared with any other model. Instead, other metrics are criticized, then used. In the end, the compare their own model using their own defined metrics, on a task relevant only to class-conditional generative models.


\subsection{Additional visuals}\label{ap:additional_visuals}

\subsubsection{Cifar}

\begin{figure}[!htb]
	\centering
	\includegraphics[width=\linewidth]{images/diffusion-bridges/vqvae_reconstruction_cifar.png}
	\caption{Reconstruction of the VQVAE model used in the following benchmarks.}
	\label{fig:cifar_vqvae}
\end{figure}

\begin{figure}[!htb]
	\centering
	\begin{minipage}[b]{0.4\textwidth}
		\includegraphics[width=1.\linewidth]{images/diffusion-bridges/sampling_pixelcnn_cifar.png}
	\end{minipage}
	\hfill
	\begin{minipage}[b]{0.4\textwidth}
		\includegraphics[width=1.\linewidth]{images/diffusion-bridges/sampling_cifar.png}
	\end{minipage}
	\caption{Samples from the PixelCNN prior (left) and from our diffusion prior (right) on CIFAR10.}

	\label{fig:cifar_priors}
\end{figure}


\subsubsection{MiniImageNet}
\begin{figure}[!htb]
	\centering
	\includegraphics[width=0.9\linewidth]{images/diffusion-bridges/vqvae_reconstruction.png}
	\caption{Reconstruction of the trained VQ-VAE on the \textit{mini}ImageNet dataset. Original images are encoded, discretised, and decoded.}
	\label{fig:miniimagenet_vqvae}
\end{figure}

\begin{figure}
	\centering
	\includegraphics[width=1.\linewidth]{images/diffusion-bridges/sampling_more.png}
	\caption{Samples from our model for the miniimagenet dataset}
	\label{fig:miniimagenet_prior_ours2}
\end{figure}


\begin{figure}
	\centering
	\includegraphics[width=1.\linewidth]{images/diffusion-bridges/conditional_sampling.png}
	\includegraphics[width=1.\linewidth]{images/diffusion-bridges/conditional_sampling_pixelcnn_1.png}
	\includegraphics[width=1.\linewidth]{images/diffusion-bridges/conditional_sampling_pixelcnn_2.png}
	\caption{Conditional sampling: Top: reconstructions from the vqvae of originals images, Middle: conditional sampling with the left side of the image as condition, for our model. Bottom 1 and 2: conditional sampling in the same context with the PixelCNN prior.}
	\label{fig:miniimagenet_prior_ours_conditional2}
\end{figure}


\begin{figure}
	\centering
	\includegraphics[width=.8\linewidth]{images/diffusion-bridges/conditional_sampling_chain_1.png}
	\includegraphics[width=.8\linewidth]{images/diffusion-bridges/conditional_sampling_chain_2.png}
	\includegraphics[width=.8\linewidth]{images/diffusion-bridges/conditional_sampling_chain_3.png}
	\includegraphics[width=.8\linewidth]{images/diffusion-bridges/conditional_sampling_chain_4.png}
	\includegraphics[width=.8\linewidth]{images/diffusion-bridges/conditional_sampling_chain_5.png}
	\includegraphics[width=.8\linewidth]{images/diffusion-bridges/conditional_sampling_chain_6.png}
	\caption{Sampling denoising chain from up to $t=0$, shown at regular intervals, conditioned on the left part of the picture. The sampling procedure is described in Appendix~\ref{ap:inpainting}.}
	\label{fig:miniimagenet_prior_ours_chain2}
\end{figure}
